#ifndef __NMENVELOPE__
#define __NMENVELOPE__

class nmEnvelope{
  int state;
  float level;
  float d_at;
  float d_dt;
  float d_rt;
  float at_count;
  float dt_count;
  float rt_count;
  float attack_time;
  float attack_level;
  float decay_time;
  float sustain_level;
  float release_time;
public:
  enum{SILENCE = 0, ATTACK_TIME, DECAY_TIME, SUSTAIN_TIME, RELEASE_TIME};
  nmEnvelope() : state(SILENCE), level(0.0f){};
  void setAttackTime(const float &at, const float &samplerate){    // at(b)
    attack_time = samplerate * at;
  }
  void setAttackLevel(const float &al){    // 0.0-1.0
    attack_level = al;
  }
  void setDecayTime(const float &dt, const float &samplerate){    // dt(b)
    decay_time = samplerate * dt;
  }
  void setSustainLevel(const float &sl){    // 0.0-1.0
    sustain_level = sl;
  }
  void setReleaseTime(const float &rt, const float &samplerate){    // rt(b)
    release_time = samplerate * rt;
  }
  int getState(){
	return state;
  }
  void noteOn();
  void noteOff();
  float getEnvelopeLevel();
};

#endif // __NMENVELOPE__