#include "nmMidiControl.hpp"

nmMidiControl::nmMidiControl()
{
  mcleftflag = 1;
  mcrightflag = 1;
  volflag = 0;
  panflag = 0;
  leftflag = 0.0f;
  rightflag = 0.0f;
  setVolume(127);
  setPan(64);
}

nmMidiControl::~nmMidiControl(){}

void nmMidiControl::setVolume(int vol){
  if(volflag != vol){
    volume = vol / 127.0f;
    volflag = vol;
    mcleftflag = 1;
    mcrightflag = 1;
  }
  return;
}

void nmMidiControl::setPan(int pan){
  if(panflag != pan){
    if(pan == 63 || pan == 64){
      pan_left = 1.0f;
      pan_right = 1.0f;
      panflag = pan;
      mcleftflag = 1;
      mcrightflag = 1;
      return;
    }
    else if(pan >= 0 && pan <= 62){
      pan_left = 1.0f;
      pan_right = (float)pan / 63.0f;
      panflag = pan;
      mcleftflag = 1;
      mcrightflag = 1;
      return;
    }
    else if(pan >= 65 && pan <= 127){
      pan_left = (127.0f - (float)pan) / 63.0f;
      pan_right = 1.0f;
      panflag = pan;
      mcleftflag = 1;
      mcrightflag = 1;
      return;
    }
  }
  return;
}

float nmMidiControl::refrectMidiLeftState(){
  if(mcleftflag == 0){
    return leftflag;
  }
  else{
    leftflag = volume * pan_left;
    mcleftflag = 0;
    return leftflag;
  }
}

float nmMidiControl::refrectMidiRightState(){
  if(mcrightflag == 0){
    return rightflag;
  }
  else{
    rightflag = volume * pan_right;
    mcrightflag = 0;
    return rightflag;
  }
}