#ifndef __NMSYNTH__
#define __NMSYNTH__

#include "AudioEffectx.h"
#include <stdio.h>
#include <string.h>

class nmSynthEdit;
class nmMidiControl;
class nmSynthControl;
class nmSynthProgram;

class nmSynth : public AudioEffectX{
public:
  nmSynth(audioMasterCallback audioMaster);
  ~nmSynth();
  virtual void setProgram(long program);
  virtual void getProgramName(char *name);
  virtual void setProgramName(char *name);
  virtual void setParameter(long index, float value);
  virtual float getParameter(long index);
  virtual bool getOutputProperties (long index, VstPinProperties* properties);
  virtual long canDo (char* text);
  virtual void setSampleRate(float sampleRate);
  virtual void process(float **inputs, float **outputs, long sampleFrames);
  virtual void processReplacing(float **inputs, float **outputs, long sampleFrames);
  virtual void resume();
  virtual long  processEvents(VstEvents* ev);
  void setWaveType(const float &wt);
  void setLowPass(const float &lp, const float &res);
  void setEnvelope(const float &at, const float &al, const float &dt, const float &sl, const float &rt);
  nmSynthEdit* getNMSE(){return vwe;}
protected:
  nmSynthProgram *programs;
  nmSynthEdit* vwe;
  nmMidiControl* mc;
  nmSynthControl* sc;
  VstMidiEvent *events;
  int eventMaxNum;
  int eventNum;
  int currentEventNo;
  int currentSample;
  int nRestSample;
  VstMidiEvent *pE;
  int nProcessSample;
  int nRestSample2;
};

#endif // __NMSYNTH__
