#ifndef __NMSYNTHEDIT__
#define __NMSYNTHEDIT__

#include <windows.h>
#include "AEffEditor.hpp"

class nmSynth;

struct VstAudioFile;

class nmSynthEdit : public AEffEditor
{
public:
  nmSynthEdit(nmSynth *effect);
  virtual ~nmSynthEdit();

  virtual long getRect(ERect **erect);
  virtual long open(void *ptr);
  virtual void close();
  virtual void idle();
  void setDial(const double &d0, const double &d1, const double &d2, const double &d3, const double &d4, const double &d5, const double &d6, const double &d7);
  void setDialWT(double wt){dial_wave_type = wt;}
  void setDialAT(double at){dial_attack_time = at;}
  void setDialAL(double al){dial_attack_level = al;}
  void setDialDT(double dt){dial_decay_time = dt;}
  void setDialSL(double sl){dial_sustain_level = sl;}
  void setDialRT(double rt){dial_release_time = rt;}
  void setDialLP(double lp){dial_low_pass = lp;}
  void setDialRes(double res){dial_resonance = res;}
  double getDialWT(){return dial_wave_type;}
  double getDialAT(){return dial_attack_time;}
  double getDialAL(){return dial_attack_level;}
  double getDialDT(){return dial_decay_time;}
  double getDialSL(){return dial_sustain_level;}
  double getDialRT(){return dial_release_time;}
  double getDialLP(){return dial_low_pass;}
  double getDialRes(){return dial_resonance;}
  static LONG WINAPI WindowProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam);
private:
  HWND hwnd_e;
  double dial_wave_type;
  double dial_attack_time;
  double dial_attack_level;
  double dial_decay_time;
  double dial_sustain_level;
  double dial_release_time;
  double dial_low_pass;
  double dial_resonance;
};

#endif // __NMSYNTHEDIT__
